/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.tables.TCoreLogic.TCoreLogicPath;
import de.ship.db.tables.records.TCoreLogicsubstRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TCoreLogicsubst extends TableImpl<TCoreLogicsubstRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_core_logicsubst</code>
     */
    public static final TCoreLogicsubst T_CORE_LOGICSUBST = new TCoreLogicsubst();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TCoreLogicsubstRecord> getRecordType() {
        return TCoreLogicsubstRecord.class;
    }

    /**
     * The column <code>common_dd.t_core_logicsubst.lastchange</code>.
     */
    public final TableField<TCoreLogicsubstRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_core_logicsubst.pk</code>.
     */
    public final TableField<TCoreLogicsubstRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>common_dd.t_core_logicsubst.fk_core_logic</code>.
     * Foreign key to t_core_logic
     */
    public final TableField<TCoreLogicsubstRecord, Integer> FK_CORE_LOGIC = createField(DSL.name("fk_core_logic"), SQLDataType.INTEGER.nullable(false), this, "Foreign key to t_core_logic");

    /**
     * The column <code>common_dd.t_core_logicsubst.value_string</code>. Result
     * value for a valid logic
     */
    public final TableField<TCoreLogicsubstRecord, String> VALUE_STRING = createField(DSL.name("value_string"), SQLDataType.CLOB.nullable(false), this, "Result value for a valid logic");

    private TCoreLogicsubst(Name alias, Table<TCoreLogicsubstRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TCoreLogicsubst(Name alias, Table<TCoreLogicsubstRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_core_logicsubst</code> table
     * reference
     */
    public TCoreLogicsubst(String alias) {
        this(DSL.name(alias), T_CORE_LOGICSUBST);
    }

    /**
     * Create an aliased <code>common_dd.t_core_logicsubst</code> table
     * reference
     */
    public TCoreLogicsubst(Name alias) {
        this(alias, T_CORE_LOGICSUBST);
    }

    /**
     * Create a <code>common_dd.t_core_logicsubst</code> table reference
     */
    public TCoreLogicsubst() {
        this(DSL.name("t_core_logicsubst"), null);
    }

    public <O extends Record> TCoreLogicsubst(Table<O> path, ForeignKey<O, TCoreLogicsubstRecord> childPath, InverseForeignKey<O, TCoreLogicsubstRecord> parentPath) {
        super(path, childPath, parentPath, T_CORE_LOGICSUBST);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TCoreLogicsubstPath extends TCoreLogicsubst implements Path<TCoreLogicsubstRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TCoreLogicsubstPath(Table<O> path, ForeignKey<O, TCoreLogicsubstRecord> childPath, InverseForeignKey<O, TCoreLogicsubstRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TCoreLogicsubstPath(Name alias, Table<TCoreLogicsubstRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TCoreLogicsubstPath as(String alias) {
            return new TCoreLogicsubstPath(DSL.name(alias), this);
        }

        @Override
        public TCoreLogicsubstPath as(Name alias) {
            return new TCoreLogicsubstPath(alias, this);
        }

        @Override
        public TCoreLogicsubstPath as(Table<?> alias) {
            return new TCoreLogicsubstPath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public Identity<TCoreLogicsubstRecord, Integer> getIdentity() {
        return (Identity<TCoreLogicsubstRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TCoreLogicsubstRecord> getPrimaryKey() {
        return Keys.PK_CORE_LOGICSUBST;
    }

    @Override
    public List<ForeignKey<TCoreLogicsubstRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_CORE_LOGICSUBST__FK_CORE_LOGICSUBST_LOGIC);
    }

    private transient TCoreLogicPath _tCoreLogic;

    /**
     * Get the implicit join path to the <code>common_dd.t_core_logic</code>
     * table.
     */
    public TCoreLogicPath tCoreLogic() {
        if (_tCoreLogic == null)
            _tCoreLogic = new TCoreLogicPath(this, Keys.T_CORE_LOGICSUBST__FK_CORE_LOGICSUBST_LOGIC, null);

        return _tCoreLogic;
    }

    @Override
    public TCoreLogicsubst as(String alias) {
        return new TCoreLogicsubst(DSL.name(alias), this);
    }

    @Override
    public TCoreLogicsubst as(Name alias) {
        return new TCoreLogicsubst(alias, this);
    }

    @Override
    public TCoreLogicsubst as(Table<?> alias) {
        return new TCoreLogicsubst(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreLogicsubst rename(String name) {
        return new TCoreLogicsubst(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreLogicsubst rename(Name name) {
        return new TCoreLogicsubst(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreLogicsubst rename(Table<?> name) {
        return new TCoreLogicsubst(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreLogicsubst where(Condition condition) {
        return new TCoreLogicsubst(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreLogicsubst where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreLogicsubst where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreLogicsubst where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreLogicsubst where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreLogicsubst where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreLogicsubst where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreLogicsubst where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreLogicsubst whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreLogicsubst whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
